/*!\file Swap.cpp
 *
 * \brief tests de plusieurs tentatives d'échange de variables par le
 * biais de fonctions.
 *
 * \author Farès Belhadj amsi@up8.edu
 * \date March 02, 2020
 */
#include <iostream>

static void swap0(int a, int b) {
    int c = a;
    a = b;
    b = c;
}

static void swap1(int *p, int *q) {
    int c = *p;
    *p = *q;
    *q = c;
}

static void swap2(int& x, int& y) {
   int c = x;
   x = y;
   y = c;
}

static void testerUnSwap(int whichOne) {
    int a = 2, b = 4;
    std::cout << "Avant swap" << whichOne << ", a = " << a << ", b = " << b << std::endl;
    switch (whichOne) {
    case 0:
        swap0(a, b);
        break;
    case 1:
        swap1(&a, &b);
        break;
    case 2:
        swap2(a, b);
        break;
    default:
        std::cerr << "Parametre incorrect" << std::endl;
        return;
    }
    std::cout << "Apres swap" << whichOne << ", a = " << a << ", b = " << b << std::endl;
}

int main(void) {
    testerUnSwap(0);
    testerUnSwap(1);
    testerUnSwap(2);
    return EXIT_SUCCESS;
}

/*
 Exercice :
 pour a et b, 2 variables du même type, 
 on peut les échanger sans utiliser une 3ème variable
    a = a ^ b;
    b = a ^ b;
    a = a ^ b;
 testez cette variante en modifiant swap0, swap1 et swap2
*/
